require(["jquery"],function($){
  $("#xwikicontent").prepend($(".xm-toc-mtt"))

  // Add link text with processed macros.
  // The {{toc/}} macro does not like macros
  // within headings...
  $("div.xm-toc ul li a").each(function(){
    var me = $(this)
    var id = (me.attr("href")||"").substring(1)
    var h = $(document.getElementById(id))
    me.empty().append(h.children().clone())
  })

  var tocBoxes = document.getElementsByClassName("xm-toc-box")
  for (var i = 0; i<tocBoxes.length; ++i) {
    var box = tocBoxes[i]
    var toc = box.getElementsByClassName("xm-toc")[0]
    var tocDisplay = "block"
    var span = box.getElementsByClassName("xm-toc-toggle")[0]
    var a = box.getElementsByClassName("xm-toc-togglelink")[0]
    var textHide = box.getAttribute("data-content-hide")
    var textShow = box.getAttribute("data-content-show")
    toc.setAttribute("xm-toc-display",tocDisplay)
    toc.setAttribute("xm-toc-visibility","1")
    span.classList.add("xm-toc-toggle")
    a.classList.add("xm-toc-togglelink")
    a.textContent = textHide
    a.href = "javascript:void(0)"

    span.addEventListener("click",function(event){
      var elSpan = this
      var elA = elSpan.childNodes[1]
      var elToc = elSpan.nextElementSibling
      if (elToc.getAttribute("xm-toc-visibility") === "1") {
        elToc.style.display = "none"
        elA.textContent = textShow
        elToc.setAttribute("xm-toc-visibility","0")
      }
      else {
        elToc.style.display = elToc.getAttribute("xm-toc-display")
        elA.textContent = textHide
        elToc.setAttribute("xm-toc-visibility","1")
      }
    })
  }
})
